

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.PrimaryKeyJoinColumn;
import javax.persistence.SecondaryTable;
import javax.persistence.SecondaryTables;
class EmployeeId implements Serializable {
  private String name; 
  private int id; 

  public EmployeeId() {}
  public EmployeeId(String country, int id) {
    this.name = country;
    this.id = id;
  }

  public String getCountry() { return name; }
  public int getId() { return id; }

  public boolean equals(Object o) { 
      return ((o instanceof EmployeeId) && 
              name.equals(((EmployeeId)o).getCountry()) &&
              id == ((EmployeeId) o).getId());

  }

  public int hashCode() { 
      return name.hashCode() + id; 
  }
}
@Entity 
@IdClass(EmployeeId.class)
@SecondaryTables({
  @SecondaryTable(name="ORG_STRUCTURE", pkJoinColumns={
      @PrimaryKeyJoinColumn(name="EMP_Name", referencedColumnName="name"),
      @PrimaryKeyJoinColumn(name="ID", referencedColumnName="ID")})
})
public class Employee {
    @Id
    private int id;
    @Id
    private String name;

    @ManyToOne 
    @JoinColumns({
        @JoinColumn(name="MGR_COUNTRY", referencedColumnName="name",
                    table="ORG_STRUCTURE"),
        @JoinColumn(name="MGR_ID", referencedColumnName="ID",
                    table="ORG_STRUCTURE")
    })
    private Employee manager;


    public int getId() {
        return id;
    }
    
    public void setId(int id) {
        this.id = id;
    }


    public String getName() {
        return name;
    }
    
    public void setName(String name) {
        this.name = name;
    }
    public String toString() {
        return "Employee id: " + getId() + " name: " + getName();
    }
}
